/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/
#ifndef SM_TOUCHPANEL_STATUS_H_
#define SM_TOUCHPANEL_STATUS_H_

//#include <nw/demo.h>
#include <nn/hid/CTR/hid_TouchPanelReader.h>
#include "../include/SmDef.h"


#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_suppress 2530 // padding added to end of struct.
#endif
//------------------------------------------------------------------------------
// Touch panel status.
class SmTouchPanelStatus
{
public:
    // Constructor
    SmTouchPanelStatus()
    : m_IsGrab( false )
    {

    }

    // Get hid hid touch panel status (for update).
    nn::hid::CTR::TouchPanelStatus* GetHidTouchPanelStatus()
    {
        return &touchPanelStatus;
    }

    // Grab.
    void Grab()
    {
        m_IsGrab = true;
    }

    // Release.
    void UnGrab()
    {
        m_IsGrab = false;
    }

    // Is it being grabbed?
    bool IsGrab()
    {
        return m_IsGrab;
    }

    // Get coordinates.
    u16 GetX()
    {
        return touchPanelStatus.x;
    }
    u16 GetY()
    {
        return touchPanelStatus.y;
    }

private:
    nn::hid::CTR::TouchPanelStatus touchPanelStatus;

    bool    m_IsGrab;
};
#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_default 2530 // padding added to end of struct.
#endif




#endif  // SM_TOUCHPANEL_STATUS_H_
