/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_FONT_RESFONT_H_
#define NW_FONT_RESFONT_H_

#include <nn/types.h>
#include <nw/font/font_ResFontBase.h>

namespace nw {
namespace font {

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
class ResFont : public ResFontBase
{
public:

    /* ------------------------------------------------------------------------
            Functions
       ------------------------------------------------------------------------ */

    //
    //

    //
                            ResFont();

    //
    virtual                 ~ResFont();

    //

    //
    //

    //
    //
    //
    //
    //
    //
    //
    //
    //
    static void RevertResource(void* resource);

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    bool                    SetResource(void* bfnt);

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    void*                   RemoveResource();

    using ResFontBase::IsManaging;

    //
    //
    //
    //
    //
    //
    static u32              GetDrawBufferSize(const void* bfnt);

    //
    //
    //
    //
    void*                   GetDrawBuffer()
    {
        return GetTextureObjectsBufferPtr();
    }

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    void*                   SetDrawBuffer(void* buffer);

    //


private:
    /* ------------------------------------------------------------------------
            Functions
       ------------------------------------------------------------------------ */

    //
    //
    //
    //
    //
    //
    //
    //
    //
    static FontInformation* Rebuild(ut::BinaryFileHeader* fileHeader);

    //
    //
    //
    //
    //
    //
    //
    //
    //
    static void* FindBlock(ut::BinaryFileHeader* fileHeader, ut::SigWord sigword);
};

}   // namespace font
}   // namespace nw

#endif //  NW_FONT_RESFONT_H_
