/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

// Input registers map
#define aPosition		v0
#define aPositionZ		v1
#define aColor			v2
#define aTexCoord		v3

// Output registers map
#define vPosition		o0
#define vFrontColor		o1
#define vTexCoord0		o2

#define CONSTANT		c95
def		CONSTANT,		0.0, 0.5, 1.0, 0.003921569

#define CONST_1			CONSTANT.z
#define CONST_1__255	CONSTANT.w

#define pos             r14
#define tmp             r15
#define cProjMtx		c0
#define cViewMtx		c4

#pragma bind_symbol ( aPosition.xy, v0, v0 )
#pragma bind_symbol ( aPositionZ.x, v1, v1 )
#pragma bind_symbol ( aColor, v2, v2 )
#pragma bind_symbol ( aTexCoord.xy, v3, v3 )

#pragma bind_symbol ( uProjection, c0, c3 )
#pragma bind_symbol ( uModelView, c4, c6 )

#pragma output_map ( position, o0 )
#pragma output_map ( color, o1 )
#pragma output_map ( texture0, o2.xy )

main:
	mov		pos.xy,			aPosition
	mov		pos.z,			aPositionZ.x
    mov     pos.w,          CONST_1
    m4x3    tmp.xyz,        pos,  cViewMtx
    mov     tmp.w,          CONST_1
    m4x4    vPosition,      tmp,        cProjMtx

    mul     vFrontColor,    aColor,     CONST_1__255
    mov     vTexCoord0,     aTexCoord.xyxy
    end
endmain:
