/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_SHADERCONFIG_H_
#define NW_SHADERCONFIG_H_

//----------------------------------------

//////////////////////////////////////////////////////////////////////////////
// Startup offset from the universal system of the user register.         //
// Used from c74, so set startup offset to c48.                       //
//////////////////////////////////////////////////////////////////////////////
#define nw_user_register_start          c48

// Enables the same camera sphere environment as NW4R.
#define NW_NORMAL_ENV_MAP

// Enabling this macro and setting it in the shader appends a feature that adds an offset to the model's parallel translation value.
// #define NW_GFX_MODEL_TRANSLATE_OFFSET_ENABLED

// The user adds definitions here and below.

//////////////////////////////////////////////////////////////////////////////
// User register to use instead of the hemispherical lights register.                           //
// You need to remove the check for hemispherical lights when making the intermediate shader files. //
//////////////////////////////////////////////////////////////////////////////
#define extension_deform                c22

///////////////////////////////////////////////////////////////////////
// User register to use instead of the vertex light register.                    //
// Registers c74-c84 will be empty in the intermediate shader file settings. //
///////////////////////////////////////////////////////////////////////
#define extension_color                 c74

// Enables the sample codes the fix in place the texture input sources.
// #define NW_FIXED_TEX_SORUCE

#endif // NW_SHADERCONFIG_H_
