/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include "ShaderConfig.h"
#include "VertexShader.h"

    //------------------------------------------
    // Color
    //------------------------------------------

l_calc_color:
    // If using vertex color, hemisphere light, and vertex light, you can insert material diffusion by entering assigning 1.
    mov     TEMP_STUS.xy,       CONST_0

    // Vertex color exists if the scale value is not 0.
    mov     TEMP0.y,    nw_attribute_scale0._W
    cmp     NEQ, NEQ,   TEMP0.xy,       CONST_0

    // Latency measures
    mov     TEMP_COLO.xyz,      CONST_0
    mov     TEMP_COLO.w,        nw_material_diffuse._W

    ifc 0, 1, COND_MODE_STA1 // When vertex color is enabled.
        // Enters values in advance as a measure against stalls due to an ifb jump.
        mul     TEMP0.xyzw,  nw_color.xyzw,       nw_attribute_scale0._W
        ifb nw_is_vertex_alpha_enable
            mul     TEMP_COLO.w,      TEMP_COLO.w,           TEMP0.w
        endif
        mul     TEMP_COLO.xyz,      TEMP0.xyz,      nw_vertex_color_scale
        mov     TEMP_STUS.x,        CONST_1
    endif

    callb nw_is_vertex_lighting, l_calc_vertex_lighting // When vertex lighting is enabled,

    callb nw_is_hemi_sphere_lighting, l_calc_hemisphere_lighting // When hemisphere lighting is enabled,

    // If vertex color, vertex light, and hemisphere light are disabled, the material's diffused colors output.
    cmp     EQ, EQ,   TEMP_STUS.xy,       CONST_0
    ifc 1, 1, COND_MODE_AND
        mov TEMP_COLO, nw_material_diffuse._XYZW
    endif
    max     o_Color,    TEMP_COLO,          CONST_0
    ret
