/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_LYT_ARCUTIL_H_
#define NW_LYT_ARCUTIL_H_

#include <nw/lyt/lyt_Arc.h>
#include <nw/lyt/lyt_ResourceAccessor.h>
#include <nw/lyt/lyt_Resources.h>
#include <nw/lyt/lyt_Types.h>

namespace nw
{
namespace lyt
{

//---------------------------------------------------------------------------
//
//
//
//
//
//---------------------------------------------------------------------------
class ArcUtil
{
public:
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    static bool OpenTextureDir(
        ARCHandle* pArcHandle,
        const wchar_t* pRootName,
        ARCDir* pDir)
    {
        return OpenResourceDir(
            pArcHandle,
            pRootName,
            res::RESOURCETYPE_TEXTURE,
            pDir);
    }

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    static bool ReadTextureDir(
        ARCDir* pDir,
        ARCDirEntry* pDirEnt)
    {
        return ReadResourceDir(pDir, L".bclim", 6, pDirEnt);
    }

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    static bool OpenFontDir(
        ARCHandle* pArcHandle,
        const wchar_t* pRootName,
        ARCDir* pDir)
    {
        return OpenResourceDir(
            pArcHandle,
            pRootName,
            res::RESOURCETYPE_FONT,
            pDir);
    }

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    static bool ReadFontDir(
        ARCDir* pDir,
        ARCDirEntry* pDirEnt)
    {
        return ReadResourceDir(pDir, L".bcfnt", 6, pDirEnt);
    }

    //
    static bool OpenResourceDir(
        ARCHandle* pArcHandle,
        const wchar_t* pRootName,
        ResType resType,
        ARCDir* pDir);

    //
    static bool ReadResourceDir(
        ARCDir* pDir,
        const wchar_t* pExtStr,
        u32 extLen,
        ARCDirEntry* pDirEnt);
};

} // namespace nw::lyt
} // namespace nw

#endif // NW_LYT_ARCUTIL_H_
