/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_LYT_BOUNDING_H_
#define NW_LYT_BOUNDING_H_

#include <nw/ut/ut_RuntimeTypeInfo.h>

#include <nw/lyt/lyt_Config.h>
#include <nw/lyt/lyt_Pane.h>

namespace nw
{
namespace lyt
{

struct ResBlockSet;
class DrawInfo;

//---------------------------------------------------------------------------
//
//
//
//
//
//---------------------------------------------------------------------------
class Bounding : public Pane
{
    typedef Pane Base;

public:
    //
    NW_UT_RUNTIME_TYPEINFO;

    //----------------------------------------
    //
    //

    //
    //
    //
    //
    Bounding()
    {}

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    explicit Bounding(const Size& size)
    {
        SetSize(size);
    }

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    Bounding(
        const res::Bounding* pBlock,
        const ResBlockSet& resBlockSet);

    //
    //
    //
    //
    virtual ~Bounding();

    //

protected:

#ifdef NW_LYT_DMPGL_ENABLED
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    virtual void DrawSelf(const DrawInfo& drawInfo);
#endif
};

} // namespace nw::lyt
} // namespace nw

#endif // NW_LYT_BOUNDING_H_

