/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_LYT_UTIL_H_
#define NW_LYT_UTIL_H_

#include <nw/lyt/lyt_Types.h>

namespace nw
{
namespace math
{

struct VEC2;
struct MTX23;

} // namespace nw::math

namespace lyt
{

class Pane;
class Layout;
class DrawInfo;
class Group;
class AnimTransform;
class TexMap;

//----------------------------------------
//
//

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
void                BindAnimation(
                        Group*          pGroup,
                        AnimTransform*  pAnimTrans,
                        bool            bRecursive  = true,
                        bool            bDisable    = false);

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
void                UnbindAnimation(
                        Group*          pGroup,
                        AnimTransform*  pAnimTrans,
                        bool            bRecursive = true);

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
void                SetAnimationEnable(
                        Group*          pGroup,
                        AnimTransform*  pAnimTrans,
                        bool            bEnable,
                        bool            bRecursive = true);

//

//----------------------------------------
//
//

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
bool                IsContain(
                        Pane*               pPane,
                        const math::VEC2&   pos);

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
Pane*               FindHitPane(
                        Pane*               pPane,
                        const math::VEC2&   pos);

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
Pane*               FindHitPane(
                        Layout*             pLayout,
                        const math::VEC2&   pos);

//

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
Pane*               GetNextPane(Pane* pPane);

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
const TextureInfo   LoadTexture(const void* pImgRes, u32 size, int texLoadFlag = 0);

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
void DeleteTexture(const TextureInfo& texInfo);

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
void CalcTextureMtx(math::MTX23* pTexMtx, const TexSRT& texSRT, const TexMap& texMap);

} // namespace nw::lyt
} // namespace nw

#endif // NW_LYT_UTIL_H_
