/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include "precompiled.h"

#include <nw/lyt/lyt_Bounding.h>
#include <nw/lyt/lyt_Common.h>
#include <nw/lyt/lyt_DrawInfo.h>
#include <nw/lyt/lyt_GraphicsResource.h>
#include <nw/lyt/lyt_ResourceAccessor.h>

namespace nw
{
namespace lyt
{

using namespace math;

NW_UT_RUNTIME_TYPEINFO_DEFINITION(Bounding, Bounding::Base);    // Defines an instance of runtime type information

Bounding::Bounding(
    const res::Bounding* pBlock,
    const ResBlockSet& resBlockSet
)
: Base(pBlock)
{
    NW_UNUSED_VARIABLE(resBlockSet)
}

Bounding::~Bounding()
{
    // OSReport("Bounding::~Bounding()\n");
}

#ifdef NW_LYT_DMPGL_ENABLED
void
Bounding::DrawSelf(const DrawInfo& drawInfo)
{
#if defined(NW_RELEASE)

    NW_UNUSED_VARIABLE(drawInfo)

#else   // #if ! defined(NW_RELEASE)

    if (drawInfo.IsDebugDrawMode())     // Draw frame
    {
        // Matrix
        LoadMtx(drawInfo);

        internal::DrawLine(drawInfo, GetVtxPos(), GetSize(), ut::Color8::GREEN);

        drawInfo.GetGraphicsResource()->ResetGlState();
    }

#endif  // #if ! defined(NW_RELEASE)
}
#endif // NW_LYT_DMPGL_ENABLED

} // namespace nw::lyt
} // namespace nw
