﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include "precompiled.h"

#include <nw/lyt/lyt_Init.h>
#include <nw/lyt/lyt_Layout.h>
#include <nw/middlewareSymbol.h>

namespace nw
{
namespace lyt
{

void
Initialize(
    nw::os::IAllocator* pAllocator,
    nw::os::IAllocator* pDeviceMemoryAllocator)
{
	NW_PUT_MIDDLEWARE_SYMBOL(lyt1);
	
    Layout::SetAllocator(pAllocator);
    Layout::SetDeviceMemoryAllocator(pDeviceMemoryAllocator);
}

} // namespace nw::lyt
} // namespace nw
