/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_LYT_FILERESOURCEACCESSOR_PUB_H_
#define NW4C_VIEWER_LYT_FILERESOURCEACCESSOR_PUB_H_

#if defined(__MWERKS__)
#pragma once
#endif

#include <nw/lyt/lyt_ResourceAccessor.h>
#include <nw/ut/ut_MovePtr.h>

namespace nw {
namespace viewer {
namespace lyt {

//---------------------------------------------------------------------------
//
//
//
//
//---------------------------------------------------------------------------
class FileResourceAccessor : public nw::lyt::ResourceAccessor
{
public:
    //
    //
    class FindInfo
    {
    public:
        //
        virtual ~FindInfo() {}

        //
        //
        //
        //
        //
        //
        //
        //
        //
        //
        //
        //
        //
        //
        virtual bool IsValid() { return false; }

        //
        //
        //
        //
        //
        //
        //
        //
        //
        //
        //
        virtual bool FindNext() { return false; }

        //
        //
        //
        //
        //
        //
        //
        virtual const char* GetName() { return 0; }
    };

    //
    typedef nw::ut::MovePtr<FindInfo> FindInfoPtr;

    //
    virtual ~FileResourceAccessor() {}

    //
    //
    //
    //
    //
    //
    //
    virtual FindInfoPtr FindResource(nw::lyt::ResType resType) = 0;
};

} // namespace nw::viewer::lyt
} // namespace nw::viewer
} // namespace nw

#endif // NW4C_VIEWER_LYT_FILERESOURCEACCESSOR_PUB_H_
