﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_VERSION_H_
#define NW4C_VIEWER_VERSION_H_

#ifndef NW_VIEWER_PRIVATE
  #include <nw/version.h>

  #define NW4C_VIEWER_VERSION_MAJOR          NW_VERSION_MAJOR
  #define NW4C_VIEWER_VERSION_MINOR          NW_VERSION_MINOR
  #define NW4C_VIEWER_VERSION_MICRO          NW_VERSION_MICRO
  #define NW4C_VIEWER_VERSION_RELSTEP        NW_VERSION_RELSTEP
#else
  #define NW4C_VIEWER_VERSION_MAJOR          3
  #define NW4C_VIEWER_VERSION_MINOR          4
  #define NW4C_VIEWER_VERSION_MICRO          0
  #define NW4C_VIEWER_VERSION_RELSTEP        0
#endif

#if 0   // for OMakefile
NW4C_VIEWER_VERSION_MAJOR                = 3
NW4C_VIEWER_VERSION_MINOR                = 4
NW4C_VIEWER_VERSION_MICRO                = 0
NW4C_VIEWER_VERSION_RELSTEP              = 0
#endif

#if (NW4C_VIEWER_VERSION_RELSTEP == 0)
#define NW4C_VIEWER_VERSION_FORMAT  "ver%d.%d.%d", NW4C_VIEWER_VERSION_MAJOR, NW4C_VIEWER_VERSION_MINOR, NW4C_VIEWER_VERSION_MICRO
#else
#define NW4C_VIEWER_VERSION_FORMAT  "ver%d.%d.%d.%d", NW4C_VIEWER_VERSION_MAJOR, NW4C_VIEWER_VERSION_MINOR, NW4C_VIEWER_VERSION_MICRO, NW4C_VIEWER_VERSION_RELSTEP
#endif

#ifndef NW4C_VIEWER_VERSION_NUMBER
#define NW4C_VIEWER_VERSION_NUMBER(major, minor, micro, relstep) (((major) << 24) | ((minor) << 16) | ((micro) << 8) | ((relstep) << 0))

#define NW4C_VIEWER_VERSION NW4C_VIEWER_VERSION_NUMBER(NW4C_VIEWER_VERSION_MAJOR, NW4C_VIEWER_VERSION_MINOR, NW4C_VIEWER_VERSION_MICRO, NW4C_VIEWER_VERSION_RELSTEP )
#endif

/* NW4C_VIEWER_VERSION_H_ */
#endif
