/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G2D_CAMERA_ACCESS_H_
#define NW4C_VIEWER_G2D_CAMERA_ACCESS_H_

#include <nn/math.h>

namespace vw  {
namespace g2d {


//====================================================
// Camera information
//====================================================
class CameraInfo
{
//--- public members --------
public:
    static CameraInfo   GetInfo() { return CameraInfo(); }

    void                GetProjMtx( nn::math::MTX44* pMtx ) const;  // Get the projection matrix
    bool                IsOrtho()               const;  // Determine whether it is an orthogonal projection
    bool                IsPerspective()         const;  // Determine whether it is an perspective projection

    void                GetViewMtx( nn::math::MTX34* pMtx ) const;  // Get the view matrix
    bool                IsWide()                const;  // Get the wide flag (already applied in the projection matrix)

    /* ctor */      CameraInfo() {}
//--- private members -------
private:
};


}   /* namespace g2d */
}   /* namespace vw  */


/* NW4C_VIEWER_G2D_CAMERA_ACCESS_H_ */
#endif


