/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4R_VIEWER_SOUND_MAIN_H_
#define NW4R_VIEWER_SOUND_MAIN_H_

#include <nw4r/config.h>
#include <nw4r/snd.h>
#include <nw4r/snd/config.h>
#include <nw4r/sdw.h>
#include <nw4r/mcs.h>

#include <dolphin/os.h> // For ax.h
#include <dolphin/ax.h> // for AX_ENABLE_REMOTE

#ifdef AX_ENABLE_REMOTE
#include <revolution/wpad.h>
#endif

namespace vw    {
namespace sound {

class FileManager;
class AnimSoundModifier;

namespace preview {
    class PreviewController;
}


#define VW_SOUND_DEFAULT_DW_LAYOUT_FILENAME "viewer_sound.brdwl"

class ModuleSound : public system::Module
{
//--------public members ------------------------
public:
    NW4R_UT_RUNTIME_TYPEINFO;
    static ModuleSound*  GetInstance();

    /* ctor */ ModuleSound() : system::Module( system::SOUND_ID, system::SOUND_PRIORITY, system::SOUND_SETUP_ORDER ) {}

    struct MemoryParams
    {
        unsigned long soundHeapSize; // Kilobyte
        unsigned long effectABufferSize; // Kilobyte
        unsigned long effectBBufferSize; // Kilobyte
        unsigned long effectCBufferSize; // Kilobyte
    };

    void                SetMemoryParams( const MemoryParams& params ) { mMemoryParams = params; }
    const MemoryParams& GetMemoryParams() const                       { return mMemoryParams;   }

protected:
    MemoryParams mMemoryParams;
};

void FocusSoundModeMCS();

}   /* namespace sound */
}   /* namespace vw    */



/* NW4R_VIEWER_SOUND_MAIN_H_ */
#endif
