/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

/*

  

 */

#ifndef NW4C_VIEWER_SYSTEM_SETTING_H_
#define NW4C_VIEWER_SYSTEM_SETTING_H_

#include <nn/types.h>
#include <viewer/common.h>

#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_suppress 1301 // padding inserted in struct.
#pragma diag_suppress 2530 // padding added to end of struct.
#endif
using namespace vw::common;

namespace vw     {
namespace system {

struct SystemSetting
{
    //
    CharArray defaultModelPath;

    //
    CharArray reloadTargetPath;

    //
    CharArray captureImagePath;

    //
    u32 frameRate;

    //
    u32 updateRate;

    //
    bool frameSkip;

    //
    u32 maxFrameSkipCount;

    //
    bool lowerPreview;

    SystemSetting() : frameRate(60), updateRate(1), frameSkip(false), maxFrameSkipCount(60), lowerPreview(false){}
    void Finalize();
};

void System_ChangeSetting( const SystemSetting* setting );
void System_GetSetting( SystemSetting* setting );
const SystemSetting* System_GetSetting();


}   /* namespace system */
}   /* namespace vw     */
#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_default 2530 // padding added to end of struct.
#pragma diag_default 1301 // padding inserted in struct.
#endif


/* NW4C_VIEWER_SYSTEM_SETTING_H_ */
#endif
