/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G2D_RESLAYOUT_H_
#define NW4C_VIEWER_G2D_RESLAYOUT_H_

#include <nw/lyt/lyt_Layout.h>
#include <nw/lyt/lyt_Animation.h>
#include "AnimManager.h"
#include "ArcFileResourceAccessor.h"

namespace vw  {
namespace g2d {

//======================================
// Layout resource management
//======================================
class ResLayout
{
//----- Public members -------------
public:
    /* ctor */ ResLayout();

    void Init();
    void Destroy(); // Layout destruction

    bool Load(
        const char* pathName,
        const char* layoutName,
        u32         type);

    bool IsValid() const
    { return (mpLayout != NULL); }

    //
    //
    //
    nw::lyt::Layout* GetLayout()
    { return mpLayout; }

    //
    //
    //
    const nw::lyt::Layout* GetLayout() const
    { return mpLayout; }

    u32 GetID() const
    { return 0; }

    //
    //
    //
    const char* GetName() const
    { return mName; }

    //
    //
    //
    AnimManager& GetAnimManager()
    { return mAnimManager; }

    //
    //
    //
    const AnimManager& GetAnimManager() const
    { return mAnimManager; }

    //
    //
    //
    void Update();

#if 0 // FIXME!
    void                    ChangeAnimeByDpd(
                                const nw::math::VEC2&     pos,
                                s32                         animSel);
#endif

    nw::os::IAllocator* GetAllocator();

//----- Private members -------------
private:
    static const u32 MAX_PATH = nn::hio::MAX_PATH;

#if 0 // FIXME!
    nw4r::lyt::McsResourceAccessor*   mpMcsResAccessor;
    nw4r::lyt::DvdResourceAccessor*   mpDvdResAccessor;
#endif
    ArcFileResourceAccessor           mArcFileResourceAccessor;
    nw::lyt::Layout*                  mpLayout;

    AnimManager                       mAnimManager;
    s32                               mCrAnimPaneIdx;
    char                              mName[ MAX_PATH ];
};


}   /* namespace g2d */
}   /* namespace vw  */


/* NW4C_VIEWER_G2D_LAYOUTINFO_H_ */
#endif


