﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G2D_SUB_MODE_MANAGER_H_
#define NW4C_VIEWER_G2D_SUB_MODE_MANAGER_H_

namespace vw {
namespace g2d {

class ISubMode;

enum SubModeType {
    SubMode_Main = 0,
    SubMode_Menu,
    SubMode_Info
};

class SubModeManagerBase
{
public:
    virtual bool Main(vw::system::HidStatus &hidStatus);
    virtual void Draw();
    void SetMode(SubModeType);
    SubModeType GetCurrentModeType() const;
    const char* GetCurrentModeName() const;

protected:
    SubModeManagerBase();
    virtual ~SubModeManagerBase();
    nw::ut::MoveArray<ISubMode*> mMode;
    int mCurrentModeIndex;
};

class SubModeManager : public SubModeManagerBase
{
public:
    static SubModeManager& GetInstance();

protected:
    SubModeManager();
    virtual ~SubModeManager();
};


}   /* namespace g2d */
}   /* namespace vw  */

#endif
