﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include <nw/viewer/lyt/ModuleLYT.h>
#include <nw/viewer/lyt/LayoutAccess.h>
#include <viewer/system.h>
#include "../../common/include/if_common.h"
#include "../include/Module.h"

namespace nw     {
namespace viewer {
namespace lyt    {

ModuleLYT::ModuleLYT()
 : sys::Module( vw::system::G2D_ID ),
   mResListener( NULL )
{
}

IResourceListener*
ModuleLYT::GetResourceListener()
{
    return mResListener;
}

void
ModuleLYT::SetResourceListener( IResourceListener* listener )
{
    mResListener = listener;
}

void
ModuleLYT::Reset()
{
    vw::g2d::ModuleG2dImpl::GetInstance().Reset();
}

void
ModuleLYT::SetGraphicsResource(nw::lyt::GraphicsResource* pGraphicsResource)
{
    vw::g2d::ModuleG2dImpl::GetInstance().SetGraphicsResource(pGraphicsResource);
}

nw::lyt::GraphicsResource*
ModuleLYT::GetGraphicsResource() const
{
    return vw::g2d::ModuleG2dImpl::GetInstance().GetGraphicsResource();
}

LayoutInfo
ModuleLYT::GetFirstLayout()
{
    return LayoutInfo::GetFirstLayout();
}


} /* namespace lyt    */
} /* namespace viewer */
} /* namespace nw4r   */
