/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G3D_ANIM_SND_UTILS_H_
#define NW4C_VIEWER_G3D_ANIM_SND_UTILS_H_

namespace vw {
namespace g3d {

// File input/output function
void LoadFile( const void *filename, u32 hashID, bool isWChar = true );
void RemoveFile( u32 hashID );

// Function to get resource count
u32 GetModelCount();
u32 GetAnimCount();

// Function to get resource
nw::gfx::Model* GetModel( u32 index );
nw::anim::res::ResAnim GetAnim( u32 index );

// Function for animation settings
void BindCurrentAnim(
    nw::gfx::Model* model,
    nw::ut::MoveArray<nw::anim::res::ResAnim>& anims,
    const char* animSetName
);

// Function for setting animation playback frame count
void SetFrame( nw::gfx::Model* model, f32 frame );

}
}

#endif
