/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G3D_LOG_SUB_MODE_H_
#define NW4C_VIEWER_G3D_LOG_SUB_MODE_H_

#include "SubMode.h"

#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_suppress 1301 // padding inserted in struct.
#endif
namespace vw {
namespace g3d {

// Log sub-mode
class LogSubMode : public ISubMode
{
public:
    enum LOG_TYPE
    {
        ERROR,
        WARNING,
        SYSTEM,
        HISTORY
    };

    LogSubMode();
    virtual ~LogSubMode();
    virtual void Main(vw::system::HidStatus& hidStatus);
    virtual void Draw();
    virtual const char* GetModeName() const;
    virtual SubModeType GetModeType() const;

    void SetLogType(LOG_TYPE type);
    void ExportLog();
    void ClearLog();

private:
    void CalcColumn();

    LOG_TYPE m_LogType;
    s32      m_Column;
};

}   /* namespace g3d */
}   /* namespace vw  */
#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_default 1301 // padding inserted in struct.
#endif

#endif
