/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G3D_SETTING_3D_MISC_H_
#define NW4C_VIEWER_G3D_SETTING_3D_MISC_H_

#include <viewer.h>

namespace vw  {
namespace g3d {

//--------------------------------
// Volume information class
//--------------------------------
class Setting {
//------- Public members ------------
public:
    enum {
        ALLOCTYPE_VRAM = 0,
        ALLOCTYPE_FCRAM
    };

    static Setting& GetInstance();

    void    SetTexAllocType( u32 alloc_type );
    void    SetModelAllocType( u32 alloc_type );

    u8      GetTexAllocType() const {return m_TexAllocType;}
    u8      GetModelAllocType() const {return m_ModelAllocType;}

//------- Private members ------------
private:
    /* ctor */      Setting();

    u8 m_TexAllocType;
    u8 m_ModelAllocType;
};


}   /* namespace g3d */
}   /* namespace vw  */


/* NW4C_VIEWER_G3D_SETTING_3D_MISC_H_ */
#endif
