/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G3D_SUB_MODE_H_
#define NW4C_VIEWER_G3D_SUB_MODE_H_

#include "SubModeManager.h"

namespace vw {
namespace g3d {

#define DECL_SUBMODE( type, base ) \
class type##SubMode : public base \
{ \
public: \
    type##SubMode(); \
    virtual ~type##SubMode(); \
    virtual void Main(vw::system::HidStatus& hidStatus); \
    virtual void Draw(); \
    virtual const char* GetModeName() const; \
    virtual SubModeType GetModeType() const; \
};

// Sub-mode interface declaration
class ISubMode
{
public:
    ISubMode() {};
    virtual ~ISubMode() {};
    virtual void Main(vw::system::HidStatus &hidStatus) = 0;
    virtual void Draw() = 0;
    virtual const char* GetModeName() const = 0;
    virtual SubModeType GetModeType() const = 0;
};

// Declaration of general-use base mode with touch panel processing
class SubModeBase : public ISubMode
{
public:
    SubModeBase();
    virtual ~SubModeBase();
    virtual void Main(vw::system::HidStatus &hidStatus);
    virtual void Draw();
};

// Sub-mode instance declaration
DECL_SUBMODE( Camera, SubModeBase )

}   /* namespace g3d */
}   /* namespace vw  */

#endif
