﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include <viewer/system.h>
#include "../include/SubMode.h"
#include "../include/InfoDrawer.h"
#include <viewer/g3d/CameraMgr.h>
#include <viewer/g3d/LightMgr.h>

namespace vw  {
namespace g3d {


#define DECL_SUBMODE_FUNC( type ) \
type##SubMode::type##SubMode() {} \
type##SubMode::~type##SubMode() {} \
void type##SubMode::Draw() { SubModeBase::Draw(); } \
const char* type##SubMode::GetModeName() const { return #type; } \
SubModeType type##SubMode::GetModeType() const { return SubMode_##type; }

DECL_SUBMODE_FUNC( Camera )


/*---------------------------------------------------------------------------*
  Name:

  Description:

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
SubModeBase::SubModeBase()
{
}

/*---------------------------------------------------------------------------*
  Name:

  Description:

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
SubModeBase::~SubModeBase()
{
}

/*---------------------------------------------------------------------------*
  Name:

  Description:

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
void
SubModeBase::Main(vw::system::HidStatus& hidStatus)
{
}

/*---------------------------------------------------------------------------*
  Name:

  Description:

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
void
SubModeBase::Draw()
{
}

/*---------------------------------------------------------------------------*
  Name:

  Description:

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
void
CameraSubMode::Main(vw::system::HidStatus& hidStatus)
{
    SubModeBase::Main(hidStatus);

    switch (InfoDrawer::GetInstance()->GetControlTargetType())
    {
    case InfoDrawer::CONTROL_CAMERA:
        CameraMgr::GetInstance()->MoveCamera3D(hidStatus);
        break;
    case InfoDrawer::CONTROL_LIGHT:
        LightMgr::GetInstance()->MoveLight3D(hidStatus);
        break;
    default:
        break;
    }
}

}   /* namespace g3d */
}   /* namespace vw  */
