﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

// Constant registers
def     c92,           0.0, 0.5, 1.0, 0.003921

// constant
#pragma bind_symbol(proj,    c0, c4)
#pragma bind_symbol(view,    c4, c6)
#pragma bind_symbol(user,    c8, c10)

// input
#pragma bind_symbol(Position.xyz,   v0,v0)
#pragma bind_symbol(TexCoord0.xy,   v1,v1)
#pragma bind_symbol(Color.xyzw,     v2,v2)

// output
#pragma output_map (position,   o0)
#pragma output_map (texture0,   o1.xy)
#pragma output_map (color,      o2)

main:

    mov     r0.w,		c92.z
    mov     r1.w,		c92.z
    mov     r0.xyz,		v0

    m4x3    r1.xyz,		r0,		c8
    m4x3    r0.xyz,		r1,		c4
    m4x4    o0,			r0,		c0

    mov     o1,			v1.xy
	mov		r0,			v2
	mul     o2,			r0,		c92.w

    end
endmain:
