/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/
#ifndef NW4CVIEWER_GRAPHICS_MEMORY_H_
#define NW4CVIEWER_GRAPHICS_MEMORY_H_


#include <viewer.h>


#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_suppress 2530 // padding added to end of struct.
#endif
namespace vw     {
namespace system {
namespace Memory {


/*
  
 */
class GraphicsMemoryAllocator
{
public:
    /*
      
     */
    void    Initialize();

    /*
      
     */
    void    Finalize();

    /*
      

      
      
      
      

      
     */
    void*   Allocate(GLenum area, GLenum aim, GLuint id, GLsizei size);

    /*
      

      
      
      
      
     */
    void    Deallocate(GLenum area, GLenum aim, GLuint id, void* addr);

    static GraphicsMemoryAllocator* GetInstance();

    //----------------------------------------
    //
    //

    //
    GraphicsMemoryAllocator();
    //
    virtual ~GraphicsMemoryAllocator() { Finalize(); }
    //

    bool CanAllocateA(u32 size);
    bool CanAllocateB(u32 size);
    bool IsInitialized();

private:
    bool m_Initialized;
};

}   /* namespace Memory */
}   /* namespace system */
}   /* namespace vw     */
#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_default 2530 // padding added to end of struct.
#endif



#endif // NW4CVIEWER_GRAPHICS_MEMORY_H_
