/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4R_VIEWER_TEMPLATE_MODULE_TEMPLATE_IMPL_H_
#define NW4R_VIEWER_TEMPLATE_MODULE_TEMPLATE_IMPL_H_

#include <viewer/template/ModuleTemplate.h>

namespace vw {
namespace tmpl {

//============================================
//
// Sample module implementation
//
//============================================
class ModuleTemplateImpl : public ModuleTemplate
{
//--------public members ------------------------
public:
    static ModuleTemplateImpl* GetInstance();

    /* ctor */      ModuleTemplateImpl(){}
    virtual void    Init    ( void );
    virtual void    Main    ( vw::system::HidStatus &hidStatus );
    virtual void    DrawInfo( void );
    virtual bool    Available( void ) {
        // With the built-in Viewer, do not use the sound or layout modules
        if( vw::system::App::GetInstance().IsEmbeddedViewer() )
        {
            return false;
        }

#if defined( NN_PCGX )
        return false;
#else
        return true;
#endif
    }
    virtual bool    IsHidden( void )  { return sHiddenFlag; }   /* While this value returns TRUE, focus does not move to this module by changing the mode with the Z Button.  *
                                                                 *          */

//--------Public static members ------------------------
    static void     SetHidden( bool hide ) { sHiddenFlag = hide; }
//--------Private members ------------------------
private:
    static bool sHiddenFlag /* = true */;
};


}   /* namespace Template */
}   /* namespace vw  */


/* NW4R_VIEWER_SAMPLE_MODULE_H_ */
#endif
